diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx b/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
index cf1aa0116c..a301227f42 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
@@ -680,92 +692,91 @@ void Segmenter< TInputImage >
   flat_region_t tempFlatRegion;
 
   typename flat_region_table_t::iterator flatPtr;
-  InputPixelType            currentValue;
-  EquivalencyTable::Pointer equivalentLabels = EquivalencyTable::New();
+  InputPixelType                         currentValue;
+  EquivalencyTable::Pointer              equivalentLabels = EquivalencyTable::New();
 
   typename OutputImageType::Pointer output = this->GetOutputImage();
 
   // Set up the iterators.
-  typename ConstNeighborhoodIterator< InputImageType >::RadiusType rad;
-  for ( i = 0; i < ImageDimension; ++i )
-    {
+  typename ConstNeighborhoodIterator<InputImageType>::RadiusType rad;
+  for (i = 0; i < ImageDimension; ++i)
+  {
     rad[i] = 1;
-    }
-  ConstNeighborhoodIterator< InputImageType > searchIt(rad, img, region);
-  NeighborhoodIterator< OutputImageType >     labelIt(rad, output, region);
-  nSize   = searchIt.Size();
+  }
+  ConstNeighborhoodIterator<InputImageType> searchIt(rad, img, region);
+  NeighborhoodIterator<OutputImageType>     labelIt(rad, output, region);
+  nSize = searchIt.Size();
   nCenter = nSize >> 1;
 
   // Sweep through the images.  Label all local minima
   // and record information for all the flat regions.
-  for ( searchIt.GoToBegin(), labelIt.GoToBegin();
-        !searchIt.IsAtEnd(); ++searchIt, ++labelIt )
-    {
+  for (searchIt.GoToBegin(), labelIt.GoToBegin(); !searchIt.IsAtEnd(); ++searchIt, ++labelIt)
+  {
     foundSinglePixelMinimum = true;
     foundFlatRegion = false;
 
     // If this pixel has been labeled already,
     // skip directly to the next iteration.
-    if ( labelIt.GetPixel(nCenter) != Self::NULL_LABEL ) { continue; }
+    if (labelIt.GetPixel(nCenter) != Self::NULL_LABEL)
+    {
+      continue;
+    }
 
     // Compare current pixel value with its neighbors.
     currentValue = searchIt.GetPixel(nCenter);
 
-    for ( i = 0; i < m_Connectivity.size; ++i )
-      {
+    for (i = 0; i < m_Connectivity.size; ++i)
+    {
       nPos = m_Connectivity.index[i];
-      if ( Math::AlmostEquals( currentValue, searchIt.GetPixel(nPos) ) )
-        {
-        foundFlatRegion  = true;
+      if (Math::AlmostEquals(currentValue, searchIt.GetPixel(nPos)))
+      {
+        foundFlatRegion = true;
         break;
-        }
-      else if ( currentValue > searchIt.GetPixel(nPos) )
-        {
+      }
+      else if (currentValue > searchIt.GetPixel(nPos))
+      {
         foundSinglePixelMinimum = false;
-        }
       }
+    }
 
-    if ( foundFlatRegion )
-      {
-      if ( labelIt.GetPixel(nPos) != Self::NULL_LABEL ) // If the flat region is
-                                                        // already
-        {                                               // labeled, label this
-                                                        // to match.
-        labelIt.SetPixel( nCenter, labelIt.GetPixel(nPos) );
-        }
+    if (foundFlatRegion)
+    {
+      if (labelIt.GetPixel(nPos) != Self::NULL_LABEL) // If the flat region is
+                                                      // already
+      {                                               // labeled, label this
+                                                      // to match.
+        labelIt.SetPixel(nCenter, labelIt.GetPixel(nPos));
+      }
       else // Add a new flat region to the table.
-        {  // Initialize its contents.
-        labelIt.SetPixel(nCenter,  m_CurrentLabel);
+      {    // Initialize its contents.
+        labelIt.SetPixel(nCenter, m_CurrentLabel);
         nPos = m_Connectivity.index[0];
 
-        tempFlatRegion.bounds_min        = maxValue;
-        tempFlatRegion.min_label_ptr     = labelIt[nPos];
-        tempFlatRegion.value             = currentValue;
-        flatRegions[m_CurrentLabel]      = tempFlatRegion;
+        tempFlatRegion.bounds_min = maxValue;
+        tempFlatRegion.min_label_ptr = labelIt[nPos];
+        tempFlatRegion.value = currentValue;
+        flatRegions[m_CurrentLabel] = tempFlatRegion;
         m_CurrentLabel = m_CurrentLabel + 1;
-        }
+      }
 
       // While we're at it, check to see if we have just linked two flat
       // regions with the same height value.  Save that info for later.
-      for ( i++; i < m_Connectivity.size; ++i )
-        {
+      for (i++; i < m_Connectivity.size; ++i)
+      {
         nPos = m_Connectivity.index[i];
-        if (   Math::AlmostEquals( searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos) )
-               && labelIt.GetPixel(nPos) != Self::NULL_LABEL
-               && labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter)
-               )
-          {
-          equivalentLabels->Add( labelIt.GetPixel(nCenter),
-                                 labelIt.GetPixel(nPos) );
-          }
+        if (Math::AlmostEquals(searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos)) &&
+            labelIt.GetPixel(nPos) != Self::NULL_LABEL && labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter))
+        {
+          equivalentLabels->Add(labelIt.GetPixel(nCenter), labelIt.GetPixel(nPos));
         }
       }
-    else if ( foundSinglePixelMinimum )
-      {
-      labelIt.SetPixel(nCenter,  m_CurrentLabel);
+    }
+    else if (foundSinglePixelMinimum)
+    {
+      labelIt.SetPixel(nCenter, m_CurrentLabel);
       m_CurrentLabel = m_CurrentLabel + 1;
-      }
     }
+  }
 
   // Merge the flat regions that we identified as connected components.
   Self::MergeFlatRegions(flatRegions, equivalentLabels);
@@ -777,42 +788,43 @@ void Segmenter< TInputImage >
 
   // Now make another pass to establish the
   // boundary values for the flat regions.
-  for ( searchIt.GoToBegin(), labelIt.GoToBegin();
-        !searchIt.IsAtEnd(); ++searchIt, ++labelIt )
-    {
-    flatPtr = flatRegions.find( labelIt.GetPixel(nCenter) );
-    if ( flatPtr != flatRegions.end() ) // If we are in a flat region
-      {                                 // Search the connectivity neighborhood
-                                        // for lesser boundary pixels.
-      for ( i = 0; i < m_Connectivity.size; ++i )
-        {
+  for (searchIt.GoToBegin(), labelIt.GoToBegin(); !searchIt.IsAtEnd(); ++searchIt, ++labelIt)
+  {
+    flatPtr = flatRegions.find(labelIt.GetPixel(nCenter));
+    if (flatPtr != flatRegions.end()) // If we are in a flat region
+    {                                 // Search the connectivity neighborhood
+                                      // for lesser boundary pixels.
+      for (i = 0; i < m_Connectivity.size; ++i)
+      {
         nPos = m_Connectivity.index[i];
 
-        if  ( labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter)
-              && searchIt.GetPixel(nPos) < ( *flatPtr ).second.bounds_min )
-          { // If this is a boundary pixel && has a lesser value than
-            // the currently recorded value...
-          ( *flatPtr ).second.bounds_min = searchIt.GetPixel(nPos);
-          ( *flatPtr ).second.min_label_ptr = labelIt[nPos];
-          }
-        if ( Math::AlmostEquals( searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos) ) )
+        if (labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter) &&
+            searchIt.GetPixel(nPos) < (*flatPtr).second.bounds_min)
+        { // If this is a boundary pixel && has a lesser value than
+          // the currently recorded value...
+          (*flatPtr).second.bounds_min = searchIt.GetPixel(nPos);
+          (*flatPtr).second.min_label_ptr = labelIt[nPos];
+        }
+        if (Math::AlmostEquals(searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos)))
+        {
+          if (labelIt.GetPixel(nPos) != NULL_LABEL)
           {
-          if ( labelIt.GetPixel(nPos) != NULL_LABEL )
-            {
             // Pick up any equivalencies we missed before.
-            equivalentLabels->Add( labelIt.GetPixel(nCenter),
-                                   labelIt.GetPixel(nPos) );
-            }
+            equivalentLabels->Add(labelIt.GetPixel(nCenter), labelIt.GetPixel(nPos));
+          }
           // If the following is encountered, it means that there is a
           // logic flaw in the first pass of this algorithm where flat
           // regions are initially detected and linked.
 #ifndef NDEBUG
-          else { itkDebugMacro("An unexpected but non-fatal error has occurred."); }
-#endif
+          else
+          {
+            itkDebugMacro("An unexpected but non-fatal error has occurred.");
           }
+#endif
         }
       }
     }
+  }
 
   // Merge the flat regions that we identified as connected components.
   Self::MergeFlatRegions(flatRegions, equivalentLabels);
@@ -821,78 +833,74 @@ void Segmenter< TInputImage >
   Self::RelabelImage(output, region, equivalentLabels);
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::GradientDescent(InputImageTypePointer img,
-                  ImageRegionType region)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::GradientDescent(InputImageTypePointer img, ImageRegionType region)
 {
   typename OutputImageType::Pointer output = this->GetOutputImage();
 
-  InputPixelType minVal;
-  unsigned int   i, nPos;
+  InputPixelType                      minVal;
+  unsigned int                        i, nPos;
   typename InputImageType::OffsetType moveIndex;
-  IdentifierType                 newLabel;
-  std::stack< IdentifierType * > updateStack;
+  IdentifierType                      newLabel;
+  std::stack<IdentifierType *>        updateStack;
 
   //
   // Set up our iterators.
   //
-  typename ConstNeighborhoodIterator< InputImageType >::RadiusType rad;
-  typename NeighborhoodIterator< OutputImageType >::RadiusType zeroRad;
-  for ( i = 0; i < ImageDimension; ++i )
-    {
+  typename ConstNeighborhoodIterator<InputImageType>::RadiusType rad;
+  typename NeighborhoodIterator<OutputImageType>::RadiusType     zeroRad;
+  for (i = 0; i < ImageDimension; ++i)
+  {
     rad[i] = 1;
     zeroRad[i] = 0;
-    }
-  ConstNeighborhoodIterator< InputImageType >
-  valueIt(rad, img, region);
-  NeighborhoodIterator< OutputImageType >
-                                         labelIt(zeroRad, output, region);
-  ImageRegionIterator< OutputImageType > it(output, region);
+  }
+  ConstNeighborhoodIterator<InputImageType> valueIt(rad, img, region);
+  NeighborhoodIterator<OutputImageType>     labelIt(zeroRad, output, region);
+  ImageRegionIterator<OutputImageType>      it(output, region);
 
   //
   // Sweep through the image and trace all unlabeled
   // pixels to a labeled region
   //
-  for ( it.GoToBegin(); !it.IsAtEnd(); ++it )
+  for (it.GoToBegin(); !it.IsAtEnd(); ++it)
+  {
+    if (it.Get() == NULL_LABEL)
     {
-    if ( it.Get() == NULL_LABEL )
-      {
-      valueIt.SetLocation( it.GetIndex() );
-      labelIt.SetLocation( it.GetIndex() );
-      newLabel = NULL_LABEL;               // Follow the path of steep-
-      while ( newLabel == NULL_LABEL )     // est descent until a label
-        {                                  // is found.
-        updateStack.push( labelIt.GetCenterPointer() );
+      valueIt.SetLocation(it.GetIndex());
+      labelIt.SetLocation(it.GetIndex());
+      newLabel = NULL_LABEL;         // Follow the path of steep-
+      while (newLabel == NULL_LABEL) // est descent until a label
+      {                              // is found.
+        updateStack.push(labelIt.GetCenterPointer());
         minVal = valueIt.GetPixel(m_Connectivity.index[0]);
         moveIndex = m_Connectivity.direction[0];
-        for ( unsigned int ii = 1; ii < m_Connectivity.size; ++ii )
-          {
+        for (unsigned int ii = 1; ii < m_Connectivity.size; ++ii)
+        {
           nPos = m_Connectivity.index[ii];
-          if ( valueIt.GetPixel(nPos) < minVal )
-            {
+          if (valueIt.GetPixel(nPos) < minVal)
+          {
             minVal = valueIt.GetPixel(nPos);
             moveIndex = m_Connectivity.direction[ii];
-            }
           }
+        }
         valueIt += moveIndex;
         labelIt += moveIndex;
         newLabel = labelIt.GetPixel(0);
-        }
+      }
 
-      while ( !updateStack.empty() ) // Update all the pixels we've traversed
-        {
-        *( updateStack.top() ) = newLabel;
+      while (!updateStack.empty()) // Update all the pixels we've traversed
+      {
+        *(updateStack.top()) = newLabel;
         updateStack.pop();
-        }
       }
     }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::DescendFlatRegions(flat_region_table_t & flatRegionTable,
-                     ImageRegionType imageRegion)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::DescendFlatRegions(flat_region_table_t & flatRegionTable, ImageRegionType imageRegion)
 {
   typename OutputImageType::Pointer output = this->GetOutputImage();
   // Assumes all pixels are labeled in the image.  Steps through the flat
@@ -901,172 +909,163 @@ void Segmenter< TInputImage >
   // relabeled to reflect these equivalencies.
   EquivalencyTable::Pointer equivalentLabels = EquivalencyTable::New();
 
-  for ( typename flat_region_table_t::const_iterator region = flatRegionTable.begin();
-        region != flatRegionTable.end(); ++region )
+  for (typename flat_region_table_t::const_iterator region = flatRegionTable.begin(); region != flatRegionTable.end();
+       ++region)
+  {
+    if (((*region).second.bounds_min < (*region).second.value) && (!(*region).second.is_on_boundary))
     {
-    if ( ( ( *region ).second.bounds_min < ( *region ).second.value )
-         && ( !( *region ).second.is_on_boundary ) )
-      {
-      equivalentLabels->Add( ( *region ).first, *( ( *region ).second.min_label_ptr ) );
-      }
+      equivalentLabels->Add((*region).first, *((*region).second.min_label_ptr));
     }
+  }
 
   equivalentLabels->Flatten();
   Self::RelabelImage(output, imageRegion, equivalentLabels);
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::UpdateSegmentTable(InputImageTypePointer input, ImageRegionType region)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::UpdateSegmentTable(InputImageTypePointer input, ImageRegionType region)
 {
   edge_table_hash_t edgeHash;
   edge_table_t      tempEdgeTable;
 
   typename edge_table_hash_t::iterator edge_table_entry_ptr;
-  typename edge_table_t::iterator edge_ptr;
+  typename edge_table_t::iterator      edge_ptr;
 
-  unsigned int i, nPos;
-  typename NeighborhoodIterator< OutputImageType >::RadiusType hoodRadius;
-  typename SegmentTableType::segment_t * segment_ptr;
-  typename SegmentTableType::segment_t temp_segment;
-  IdentifierType segment_label;
+  unsigned int                                               i, nPos;
+  typename NeighborhoodIterator<OutputImageType>::RadiusType hoodRadius;
+  typename SegmentTableType::segment_t *                     segment_ptr;
+  typename SegmentTableType::segment_t                       temp_segment;
+  IdentifierType                                             segment_label;
 
   InputPixelType lowest_edge;
 
   // Grab the data we need.
-  typename OutputImageType::Pointer output    = this->GetOutputImage();
+  typename OutputImageType::Pointer  output = this->GetOutputImage();
   typename SegmentTableType::Pointer segments = this->GetSegmentTable();
 
   // Set up some iterators.
-  for ( i = 0; i < ImageDimension; i++ )
-    {
+  for (i = 0; i < ImageDimension; i++)
+  {
     hoodRadius[i] = 1;
-    }
-  ConstNeighborhoodIterator< InputImageType > searchIt(hoodRadius, input, region);
-  NeighborhoodIterator< OutputImageType >     labelIt(hoodRadius, output, region);
+  }
+  ConstNeighborhoodIterator<InputImageType> searchIt(hoodRadius, input, region);
+  NeighborhoodIterator<OutputImageType>     labelIt(hoodRadius, output, region);
 
   IdentifierType hoodCenter = searchIt.Size() >> 1;
 
-  for ( searchIt.GoToBegin(), labelIt.GoToBegin(); !searchIt.IsAtEnd();
-        ++searchIt, ++labelIt )
-    {
+  for (searchIt.GoToBegin(), labelIt.GoToBegin(); !searchIt.IsAtEnd(); ++searchIt, ++labelIt)
+  {
     segment_label = labelIt.GetPixel(hoodCenter);
 
     // Find the segment corresponding to this label
     // and update its minimum value if necessary.
     segment_ptr = segments->Lookup(segment_label);
     edge_table_entry_ptr = edgeHash.find(segment_label);
-    if ( segment_ptr == ITK_NULLPTR ) // This segment not yet identified.
-      {                     // So add it to the table.
+    if (segment_ptr == nullptr) // This segment not yet identified.
+    {                           // So add it to the table.
       temp_segment.min = searchIt.GetPixel(hoodCenter);
       segments->Add(segment_label, temp_segment);
-      typedef typename edge_table_hash_t::value_type ValueType;
-      edgeHash.insert( ValueType(segment_label,
-                                 tempEdgeTable) );
+      using ValueType = typename edge_table_hash_t::value_type;
+      edgeHash.insert(ValueType(segment_label, tempEdgeTable));
 
       edge_table_entry_ptr = edgeHash.find(segment_label);
-      }
-    else if ( searchIt.GetPixel(hoodCenter) < segment_ptr->min )
-      {
+    }
+    else if (searchIt.GetPixel(hoodCenter) < segment_ptr->min)
+    {
       segment_ptr->min = searchIt.GetPixel(hoodCenter);
-      }
+    }
 
     // Look up each neighboring segment in this segment's edge table.
     // If an edge exists, compare (and reset) the minimum edge value.
     // Note that edges are located *between* two adjacent pixels and
     // the value is taken to be the maximum of the two adjacent pixel
     // values.
-    for ( i = 0; i < m_Connectivity.size; ++i )
-      {
+    for (i = 0; i < m_Connectivity.size; ++i)
+    {
       nPos = m_Connectivity.index[i];
-      if ( labelIt.GetPixel(nPos) != segment_label
-           && labelIt.GetPixel(nPos) != NULL_LABEL )
+      if (labelIt.GetPixel(nPos) != segment_label && labelIt.GetPixel(nPos) != NULL_LABEL)
+      {
+        if (searchIt.GetPixel(nPos) < searchIt.GetPixel(hoodCenter))
         {
-        if ( searchIt.GetPixel(nPos) < searchIt.GetPixel(hoodCenter) )
-          {
           lowest_edge = searchIt.GetPixel(hoodCenter); // We want the
-          }
+        }
         else
-          {
-          lowest_edge = searchIt.GetPixel(nPos);       // max of the
-          }
+        {
+          lowest_edge = searchIt.GetPixel(nPos); // max of the
+        }
         // adjacent pixels
 
-        edge_ptr = ( *edge_table_entry_ptr ).second.find( labelIt.GetPixel(nPos) );
-        if ( edge_ptr == ( *edge_table_entry_ptr ).second.end() )
-          {     // This edge has not been identified yet.
-          typedef typename edge_table_t::value_type ValueType;
-          ( *edge_table_entry_ptr ).second.insert(
-            ValueType(labelIt.GetPixel(nPos), lowest_edge) );
-          }
-        else if ( lowest_edge < ( *edge_ptr ).second )
-          {
-          ( *edge_ptr ).second = lowest_edge;
-          }
+        edge_ptr = (*edge_table_entry_ptr).second.find(labelIt.GetPixel(nPos));
+        if (edge_ptr == (*edge_table_entry_ptr).second.end())
+        { // This edge has not been identified yet.
+          using ValueType = typename edge_table_t::value_type;
+          (*edge_table_entry_ptr).second.insert(ValueType(labelIt.GetPixel(nPos), lowest_edge));
+        }
+        else if (lowest_edge < (*edge_ptr).second)
+        {
+          (*edge_ptr).second = lowest_edge;
         }
       }
     }
+  }
 
   //
   // Copy all of the edge tables into the edge lists of the
   // segment table.
   //
-  IdentifierType listsz;
+  IdentifierType                                   listsz;
   typename SegmentTableType::edge_list_t::iterator list_ptr;
-  for ( edge_table_entry_ptr = edgeHash.begin();
-        edge_table_entry_ptr != edgeHash.end();
-        edge_table_entry_ptr++ )
-    {
+  for (edge_table_entry_ptr = edgeHash.begin(); edge_table_entry_ptr != edgeHash.end(); ++edge_table_entry_ptr)
+  {
     // Lookup the corresponding segment entry
-    segment_ptr = segments->Lookup( ( *edge_table_entry_ptr ).first );
-    if ( segment_ptr == ITK_NULLPTR )
-      {
-      itkGenericExceptionMacro (<< "UpdateSegmentTable:: An unexpected and fatal error has occurred.");
-      }
+    segment_ptr = segments->Lookup((*edge_table_entry_ptr).first);
+    if (segment_ptr == nullptr)
+    {
+      itkGenericExceptionMacro(<< "UpdateSegmentTable:: An unexpected and fatal error has occurred.");
+    }
 
     // Copy into the segment list
-    listsz = static_cast< IdentifierType >( ( *edge_table_entry_ptr ).second.size() );
+    listsz = static_cast<IdentifierType>((*edge_table_entry_ptr).second.size());
     segment_ptr->edge_list.resize(listsz);
-    edge_ptr = ( *edge_table_entry_ptr ).second.begin();
+    edge_ptr = (*edge_table_entry_ptr).second.begin();
     list_ptr = segment_ptr->edge_list.begin();
-    while ( edge_ptr != ( *edge_table_entry_ptr ).second.end() )
-      {
-      list_ptr->label = ( *edge_ptr ).first;
-      list_ptr->height = ( *edge_ptr ).second;
-      edge_ptr++;
-      list_ptr++;
-      }
+    while (edge_ptr != (*edge_table_entry_ptr).second.end())
+    {
+      list_ptr->label = (*edge_ptr).first;
+      list_ptr->height = (*edge_ptr).second;
+      ++edge_ptr;
+      ++list_ptr;
+    }
 
     // Clean up memory as we go
-    ( *edge_table_entry_ptr ).second.clear();
-    }
+    (*edge_table_entry_ptr).second.clear();
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::BuildRetainingWall(InputImageTypePointer img,
-                     ImageRegionType region,
-                     InputPixelType value)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::BuildRetainingWall(InputImageTypePointer img, ImageRegionType region, InputPixelType value)
 {
   unsigned int i;
 
-  typename ImageRegionType::SizeType sz;
+  typename ImageRegionType::SizeType  sz;
   typename ImageRegionType::IndexType idx;
-  ImageRegionType reg;
+  ImageRegionType                     reg;
 
   // Loop through the dimensions and populate the LOW and HIGH faces regions.
-  for ( i = 0; i < ImageDimension; ++i )
-    {
-    idx = region.GetIndex();       // LOW face
-    sz  = region.GetSize();
+  for (i = 0; i < ImageDimension; ++i)
+  {
+    idx = region.GetIndex(); // LOW face
+    sz = region.GetSize();
     sz[i] = 1;
     reg.SetIndex(idx);
     reg.SetSize(sz);
     Segmenter::SetInputImageValues(img, reg, value);
-    idx[i] = region.GetSize()[i] + region.GetIndex()[i] - 1;  // HIGH face
+    idx[i] = region.GetSize()[i] + region.GetIndex()[i] - 1; // HIGH face
     reg.SetIndex(idx);
     Segmenter::SetInputImageValues(img, reg, value);
-    }
+  }
 }
 
 /*
@@ -1074,57 +1073,60 @@ void Segmenter< TInputImage >
   Algorithm helper methods and debugging methods
   ----------------------------------------------------------------------------
 */
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::SetInputImageValues(InputImageTypePointer img,
-                      ImageRegionType region,
-                      InputPixelType value)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::SetInputImageValues(InputImageTypePointer img, ImageRegionType region, InputPixelType value)
 {
-  ImageRegionIterator< InputImageType > it(img, region);
+  ImageRegionIterator<InputImageType> it(img, region);
   it.GoToBegin();
-  while ( !it.IsAtEnd() )
-    {
+  while (!it.IsAtEnd())
+  {
     it.Set(value);
     ++it;
-    }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::SetOutputImageValues(OutputImageTypePointer img,
-                       ImageRegionType region,
-                       IdentifierType value)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::SetOutputImageValues(OutputImageTypePointer img, ImageRegionType region, IdentifierType value)
 {
-  ImageRegionIterator< OutputImageType > it(img, region);
+  ImageRegionIterator<OutputImageType> it(img, region);
   it.GoToBegin();
-  while ( !it.IsAtEnd() )
-    {
+  while (!it.IsAtEnd())
+  {
     it.Set(value);
     ++it;
-    }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::MinMax(InputImageTypePointer img, ImageRegionType region,
-         InputPixelType & min, InputPixelType & max)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::MinMax(InputImageTypePointer img,
+                               ImageRegionType       region,
+                               InputPixelType &      min,
+                               InputPixelType &      max)
 {
-  ImageRegionIterator< InputImageType > it(img, region);
+  ImageRegionIterator<InputImageType> it(img, region);
   it.GoToBegin();
   min = it.Value();
   max = it.Value();
-  while ( !it.IsAtEnd() )
+  while (!it.IsAtEnd())
+  {
+    if (it.Get() > max)
     {
-    if ( it.Get() > max ) { max = it.Get(); }
-    if ( it.Get() < min ) { min = it.Get(); }
-    ++it;
+      max = it.Get();
+    }
+    if (it.Get() < min)
+    {
+      min = it.Get();
     }
+    ++it;
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::MergeFlatRegions(flat_region_table_t & regions,
-                   EquivalencyTable::Pointer eqTable)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::MergeFlatRegions(flat_region_table_t & regions, EquivalencyTable::Pointer eqTable)
 {
   // Note that the labels must have no interdependencies.  That is,
   // every key must map to a value that is not itself a key in the
@@ -1134,106 +1136,103 @@ void Segmenter< TInputImage >
   eqTable->Flatten();
 
   typename flat_region_table_t::iterator a, b;
-  for ( EquivalencyTable::ConstIterator it = eqTable->Begin();
-        it != eqTable->End(); ++it )
+  for (EquivalencyTable::ConstIterator it = eqTable->Begin(); it != eqTable->End(); ++it)
+  {
+    if (((a = regions.find((*it).first)) == regions.end()) || ((b = regions.find((*it).second)) == regions.end()))
     {
-    if ( ( ( a = regions.find( ( *it ).first ) ) == regions.end() )
-         || ( ( b = regions.find( ( *it ).second ) ) == regions.end() ) )
-      {
-      itkGenericExceptionMacro (<< "MergeFlatRegions:: An unexpected and fatal error has occurred.");
-      }
+      itkGenericExceptionMacro(<< "MergeFlatRegions:: An unexpected and fatal error has occurred.");
+    }
 
-    if ( ( *a ).second.bounds_min < ( *b ).second.bounds_min )
-      {
-      ( *b ).second.bounds_min = ( *a ).second.bounds_min;
-      ( *b ).second.min_label_ptr = ( *a ).second.min_label_ptr;
-      }
+    if ((*a).second.bounds_min < (*b).second.bounds_min)
+    {
+      (*b).second.bounds_min = (*a).second.bounds_min;
+      (*b).second.min_label_ptr = (*a).second.min_label_ptr;
+    }
 
     regions.erase(a);
-    }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::RelabelImage(OutputImageTypePointer img,
-               ImageRegionType region,
-               EquivalencyTable::Pointer eqTable)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::RelabelImage(OutputImageTypePointer    img,
+                                     ImageRegionType           region,
+                                     EquivalencyTable::Pointer eqTable)
 {
   eqTable->Flatten();
 
-  IdentifierType                         temp;
-  ImageRegionIterator< OutputImageType > it(img, region);
+  IdentifierType                       temp;
+  ImageRegionIterator<OutputImageType> it(img, region);
 
   it.GoToBegin();
-  while ( !it.IsAtEnd() )
+  while (!it.IsAtEnd())
+  {
+    temp = eqTable->Lookup(it.Get());
+    if (temp != it.Get())
     {
-    temp = eqTable->Lookup( it.Get() );
-    if ( temp != it.Get() )  { it.Set(temp); }
-    ++it;
+      it.Set(temp);
     }
+    ++it;
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >::Threshold(InputImageTypePointer destination,
-                                         InputImageTypePointer source,
-                                         const ImageRegionType source_region,
-                                         const ImageRegionType destination_region,
-                                         InputPixelType threshold)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::Threshold(InputImageTypePointer destination,
+                                  InputImageTypePointer source,
+                                  const ImageRegionType source_region,
+                                  const ImageRegionType destination_region,
+                                  InputPixelType        threshold)
 {
-  ImageRegionIterator< InputImageType > dIt(destination, destination_region);
-  ImageRegionIterator< InputImageType > sIt(source, source_region);
+  ImageRegionIterator<InputImageType> dIt(destination, destination_region);
+  ImageRegionIterator<InputImageType> sIt(source, source_region);
 
   dIt.GoToBegin();
   sIt.GoToBegin();
 
   // Assumes that source_region and destination region are the same size.  Does
   // no checking!!
-  if ( NumericTraits< InputPixelType >::is_integer )
-    {
+  if (NumericTraits<InputPixelType>::is_integer)
+  {
     // integral data type, if any pixel is at the maximum possible
     // value for the data type, then drop the value by one intensity
     // value. This the watershed algorithm to construct a "barrier" or
     // "wall" around the image that will stop the watershed without
     // requiring a expensive boundary condition checks.
-    while ( !dIt.IsAtEnd() )
-      {
+    while (!dIt.IsAtEnd())
+    {
       InputPixelType tmp = sIt.Get();
-      if ( tmp < threshold )
-        {
+      if (tmp < threshold)
+      {
         dIt.Set(threshold);
-        }
-CLANG_PRAGMA_PUSH
-CLANG_SUPPRESS_Wfloat_equal
-      else if ( tmp == NumericTraits< InputPixelType >::max() )
-CLANG_PRAGMA_POP
-        {
-        dIt.Set(tmp - NumericTraits< InputPixelType >::OneValue());
-        }
-      else
-        {
-        dIt.Set(tmp);
-        }
+      }
+      CLANG_PRAGMA_PUSH
+      CLANG_SUPPRESS_Wfloat_equal else if (tmp == NumericTraits<InputPixelType>::max()) CLANG_PRAGMA_POP
+      {
+        dIt.Set(tmp - NumericTraits<InputPixelType>::OneValue());
+      }
+      else { dIt.Set(tmp); }
       ++dIt;
       ++sIt;
-      }
     }
+  }
   else
-    {
+  {
     // floating point data, no need to worry about overflow
-    while ( !dIt.IsAtEnd() )
+    while (!dIt.IsAtEnd())
+    {
+      if (sIt.Get() < threshold)
       {
-      if ( sIt.Get() < threshold )
-        {
         dIt.Set(threshold);
-        }
+      }
       else
-        {
-        dIt.Set( sIt.Get() );
-        }
+      {
+        dIt.Set(sIt.Get());
+      }
       ++dIt;
       ++sIt;
-      }
     }
+  }
 }
 
 /*
